package com.lazydroid.autoupdateapk;

import android.Manifest;
import android.app.Activity;
import android.net.Uri;
import android.util.Log;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import org.apache.cordova.CordovaArgs;
import org.apache.cordova.CallbackContext;
import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.PluginResult;
import android.content.BroadcastReceiver;
import android.content.Intent;
import android.content.IntentFilter;
import android.database.Cursor;
import android.app.DownloadManager;
import android.content.Context;
import android.os.Bundle;
import android.os.Environment;

public class AutoUpdateApk extends CordovaPlugin {
	public static final int PERMISSION_DENIED_ERROR = 20;

    public static final String WRITE = Manifest.permission.WRITE_EXTERNAL_STORAGE;
    public static final String READ = Manifest.permission.READ_EXTERNAL_STORAGE;

    public static final int REQ_CODE = 0;
    private static final String TAG = "AutoUpdateApk";
    private static final String ACTION_UPDATE = "update";
    private static final int PICK_FILE_REQUEST = 1;
    CallbackContext callback;
    protected JSONArray args;
    protected CallbackContext callbackContext;
    BroadcastReceiver broadcastReceiver;
    DownloadManager mgr;
    long downloadref;
	
	@Override
    public boolean execute(String action, JSONArray data, CallbackContext callbackContext) throws JSONException {
		
		if(action.equals(ACTION_UPDATE)){           
            if (cordova.hasPermission(READ) && cordova.hasPermission(WRITE)) {
                launchActivity(data);
            } else {
                getPermission();
            }
            return true;
        } 

        return false;
    }
    protected void getPermission() {
        cordova.requestPermissions(this, REQ_CODE, new String[]{WRITE, READ});
    }
    protected void launchActivity(JSONArray apkAr) throws JSONException {       
        String apk_path = apkAr.getString(0);
        String apk_name = apkAr.getString(1);
        mgr = (DownloadManager) cordova.getActivity().getSystemService(cordova.getActivity().DOWNLOAD_SERVICE);
        DownloadManager.Request request = new DownloadManager.Request(Uri.parse(apk_path));
        request.setDescription("downloading...");
        request.setTitle(apk_name);
        request.allowScanningByMediaScanner();
        request.setNotificationVisibility(DownloadManager.Request.VISIBILITY_VISIBLE_NOTIFY_COMPLETED);
        request.setDestinationInExternalFilesDir(cordova.getActivity(), Environment.DIRECTORY_DOWNLOADS, apk_path);
        downloadref = mgr.enqueue(request);
        broadcastReceiver = new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                long referid = intent.getLongExtra(DownloadManager.EXTRA_DOWNLOAD_ID, -1);
                if (downloadref == referid) {
                    Intent installIntent = new Intent(Intent.ACTION_VIEW);
                    installIntent.setDataAndType(mgr.getUriForDownloadedFile(downloadref),
                            "application/vnd.android.package-archive");
                    installIntent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                    cordova.getActivity().startActivity(installIntent);
                } else {
                    //Display.log("Error Downloading");
                }
            }
        };
        cordova.getActivity().registerReceiver(broadcastReceiver, new IntentFilter(DownloadManager.ACTION_DOWNLOAD_COMPLETE));
    }
}
